﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;


namespace WebShop.Models
{
    public class Customer
    {
        public int CustomerId { get; set; }
        public string CustomerName { get; set; }
        public string CustomerNumber { get; set; }
        public string UserName { get; set; }
        public string Password { get; set; }

        public List<Customer> GetCustomerData(string customerNumber)
        {
            string connectionString = "DATA SOURCE=LOCALHOST\\SQLEXPRESS;DATABASE=WEBSHOP;Integrated Security = True";

            List<Customer> customerDataList = new List<Customer>();

            SqlConnection con = new SqlConnection(connectionString);

            string sqlQuery = "select * from CUSTOMER where CustomerNumber=" + customerNumber;

            con.Open();

            SqlCommand cmd = new SqlCommand(sqlQuery, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Customer customerData = new Customer();

                    customerData.CustomerId = Convert.ToInt32(dr["CustomerId"]);
                    customerData.CustomerName = dr["CustomerName"].ToString();
                    customerData.CustomerNumber = dr["CustomerNumber"].ToString();
                    customerData.UserName = dr["UserName"].ToString();
                    customerData.Password = dr["Password"].ToString();

                    customerDataList.Add(customerData);
                }
            }
            return customerDataList;
        }


        public List<Customer> GetCustomerDataUsingSQLParameters(int customerNumber)
        {
            string connectionString = "DATA SOURCE=LOCALHOST\\SQLEXPRESS;DATABASE=WEBSHOP;Integrated Security = True";

            List<Customer> customerDataList = new List<Customer>();

            SqlConnection con = new SqlConnection(connectionString);

            string sqlQuery = "select * from CUSTOMER where CustomerNumber = @customernumber";

            con.Open();

            SqlCommand cmd = new SqlCommand(sqlQuery, con);

            var customerNumberParameter = new SqlParameter("customernumber", SqlDbType.Int);
            customerNumberParameter.Value = customerNumber;

            cmd.Parameters.Add(customerNumberParameter);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Customer customerData = new Customer();

                    customerData.CustomerId = Convert.ToInt32(dr["CustomerId"]);
                    customerData.CustomerName = dr["CustomerName"].ToString();
                    customerData.CustomerNumber = dr["CustomerNumber"].ToString();
                    customerData.UserName = dr["UserName"].ToString();
                    customerData.Password = dr["Password"].ToString();

                    customerDataList.Add(customerData);
                }
            }
            return customerDataList;
        }


        public List<Customer> VerifyLogin(string userName, string userPassword)
        {
            string connectionString = "DATA SOURCE=LOCALHOST\\SQLEXPRESS;DATABASE=WEBSHOP;Integrated Security = True";

            List<Customer> customerDataList = new List<Customer>();

            SqlConnection con = new SqlConnection(connectionString);

            string sqlQuery = "select * from CUSTOMER where UserName='" + userName + "' AND Password ='" + userPassword + "'";

            con.Open();

            SqlCommand cmd = new SqlCommand(sqlQuery, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Customer customerData = new Customer();

                    customerData.CustomerId = Convert.ToInt32(dr["CustomerId"]);
                    customerData.CustomerName = dr["CustomerName"].ToString();
                    customerData.CustomerNumber = dr["CustomerNumber"].ToString();
                    customerData.UserName = dr["UserName"].ToString();
                    customerData.Password = dr["Password"].ToString();

                    customerDataList.Add(customerData);
                }
            }
            return customerDataList;
        }

    }
}
