using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebShop.Models;

namespace WebShop.Pages
{
    public class CustomerModel : PageModel
    {
        //public string customerNumber;
        public int customerNumber;
        public List<Customer> customerDataList = new List<Customer>();

        public void OnGet()
        {
            
        }

        public void OnPost()
        {
            Customer customer = new Customer();

            customerNumber = Convert.ToInt32(Request.Form["CustomerNumber"]);

            //customerDataList = customer.GetCustomerData(customerNumber);

            customerDataList = customer.GetCustomerDataUsingSQLParameters(customerNumber);
        }
    }
}